{This unit contains all the message codes used in NStruct}

unit NStruct_MsgCodes;

interface

const    STRUCT_OK        =         $0000;    // no error
         STRUCT_MEM       =         $0001;    // memory error
         STRUCT_MATH_ERR  =         $0002;    // mathematics error
         STRUCT_ILL_COND  =         $0004;    // ill conditioned system
         STRUCT_TOO_MUCH  =         $0008;    // too much unknowns
         STRUCT_USR_STOP  =         $0010;    // user stop
         STRUCT_NOT_FOUND =         $0020;    // no solution found
         STRUCT_USR_ELAST =         $0040;    // non valid elastic forces defined by user
         STRUCT_USR_CONST =         $0080;    // non valid constraints defined by user
         STRUCT_ERR       =         $0100;    // unknown error
         STRUCT_THR       =         $0200;    // thread error
         MinCode = 0;
         MaxCode = 10;

type TStructError = array [MinCode .. MaxCode] of record
                                                   code : longword;
                                                   mess : pchar;
                                                  end;
const ErrorCodes : TStructError
                      = ((code : STRUCT_OK         ;   mess : 'no error'),
                         (code : STRUCT_MEM        ;   mess : 'memory error'),
                         (code : STRUCT_MATH_ERR   ;   mess : 'mathematics error'),
                         (code : STRUCT_ILL_COND   ;   mess : 'ill conditioned system'),
                         (code : STRUCT_TOO_MUCH   ;   mess : 'too much unknowns'),
                         (code : STRUCT_USR_STOP   ;   mess : 'user stop'),
                         (code : STRUCT_NOT_FOUND  ;   mess : 'no solution found'),
                         (code : STRUCT_USR_ELAST  ;   mess : 'invalid elastic forces'),
                         (code : STRUCT_USR_CONST  ;   mess : 'invalid constraints'),
                         (code : STRUCT_ERR        ;   mess : 'unknown error'),
                         (code : STRUCT_THR        ;   mess : 'thread error'));

function GetStrError (cde : longword) : string;
                         
implementation

function GetStrError (cde : longword) : string;
var i, c : longword;
    st : string;
begin
 st := '';
 if cde = STRUCT_OK then st := ErrorCodes [MinCode].mess
 else
  for i := MinCode + 1 to MaxCode do
   begin
    c := cde and ErrorCodes [i].code;
    if c = ErrorCodes [i].code then
     if st <> '' then st := st + ' + ' + ErrorCodes [i].mess
     else  st := st + ErrorCodes [i].mess
    else;
   end;
 Result := st;
end;

end.
